app/core/urls.py
from django.urls import path
from . import views

app_name='animals'
urlpatterns = [

    path('', views.Main.as_view(), name="main"),

    path('animal/', views.MainAnimal.as_view(), name="main_animal"),
    path('animal/<int:pk>', views.DetailAnimal.as_view(), name="detail_animal" ),
    path('animal/create/', views.AnimalCreate.as_view(), name='create_animal'),
    path('animal/<int:pk>/update/', views.AnimalUpdate.as_view(), name='update_animal'),
    path('animal/<int:pk>/delete/', views.AnimalDelete.as_view(), name='delete_animal'),

    path('routine/', views.MainRoutine.as_view(), name="main_routine"),
    path('routine/<int:pk>', views.DetailRoutine.as_view(), name="detail_routine"),
    path('routine/create/', views.RoutineCreate.as_view(), name='create_routine'),
    path('routine/<int:pk>/update/', views.RoutineUpdate.as_view(), name='update_routine'),
    path('routine/<int:pk>/delete/', views.RoutineDelete.as_view(), name='delete_routine'),


]

app/src/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf.urls.static import static
from django.conf import settings
from django.conf.urls.i18n import i18n_patterns

urlpatterns =[
    path('admin/', admin.site.urls),
    path('', include("core.urls")),
    path('accounts/', include('django.contrib.auth.urls')),

] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)


if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

app/core/models.py
from django.db import models
from django.utils import timezone
import datetime

class Animal(models.Model):
    name=models.CharField(max_length=200)
    species = models.ForeignKey('Species', on_delete=models.CASCADE)
    dateOfBirth = models.DateField(default=timezone.now)
    sex = models.ForeignKey('Sex', on_delete=models.CASCADE)
    parents = models.ForeignKey('Parents', on_delete=models.SET_NULL, blank=True, null=True)
    def __str__(self):
        return "{0} , {1}".format(self.name,self.species)

class Species(models.Model):
    name = models.CharField(max_length=200)
    nameLatin = models.CharField(max_length=200)

    def __str__(self):
        return "{0}".format(self.name)

class Sex(models.Model):
    name=name = models.CharField(max_length=20)

    def __str__(self):
        return "{0}".format(self.name)

class Routine(models.Model):
    name = models.CharField(max_length=200)
    routineType = models.CharField(max_length=200)
    startsAt = models.DateTimeField(default=datetime.datetime.now())
    animal = models.ForeignKey('Animal', on_delete=models.CASCADE, null=True)

    def __str__(self):
        return "{0} | {1}".format(self.name, self.animal)

class Parents(models.Model):
    mother=models.ForeignKey('Animal',on_delete=models.CASCADE, null=True,blank=True, related_name='mother')
    father = models.ForeignKey('Animal',on_delete=models.CASCADE,null=True, blank=True, related_name='father')

    def __str__(self):
        return "{0} & {1}".format(self.mother.name, self.father.name)

app/core/forms.py
from .models import Application, Recommend
from django.forms import ModelForm, TextInput, Textarea
from django.utils.translation import ugettext_lazy as _
from phonenumber_field.widgets import PhoneNumberInternationalFallbackWidget



class ApplicationForm(ModelForm):
    class Meta:
        model = Application
        fields = ['name', 'surname', 'phone', 'comment']

        widgets = {
            'name': TextInput(attrs={
                'placeholder': _('Имя'),
                'class': 'form-control',
            }),
            'surname': TextInput(attrs={
                'placeholder': _('Фамилия'),
                'class': 'form-control',
            }),
            'phone': PhoneNumberInternationalFallbackWidget(attrs={
                'placeholder': _('Телефон'),
                'class': 'form-control',
            }),
            'comment': Textarea(attrs={
                'placeholder': _('Комментарий'),
                'class': 'form-control',
                'rows': 5,
            })
        }


class RecommendForm(ModelForm):
    class Meta:
        model = Recommend
        fields = ['title', 'name', 'comment']

        widgets = {
            'title': TextInput(attrs={
                'class': 'form-control',
                'placeholder': _('Заголовок'),
            }),
            'name': TextInput(attrs={
                'class': 'form-control',
                'placeholder': _('Ваше имя')
            }),
            'comment': Textarea(attrs={
                'class': 'form-control',
                'placeholder': _('Комментарий')
            })
        }

app/core/views.py
from django.template import loader
from django.contrib import messages
from django.http import HttpResponse
from django.shortcuts import render, redirect
from django.views.generic import CreateView, UpdateView, DeleteView, ListView, DetailView,View
from .models import Animal,Routine
from django.contrib.auth.mixins import LoginRequiredMixin
from django.urls import reverse_lazy
# example
#def index(request):
    #template = loader.get_template('core/animal_main.html')
    #return HttpResponse(template.render({}, request))


#############################  MAIN  #########################################

class Main(View):
    template = 'core/main.html'
    success_url = reverse_lazy('animal:main')

    def get(self, request):
        ctx = {'countAnimals': Animal.objects.count(),'countRoutines': Routine.objects.count()}
        return render(request, self.template, ctx)

#############################  ANIMALS  #########################################
class MainAnimal(ListView):
    model= Animal
    template_name = "core/animal_main.html"

class DetailAnimal(LoginRequiredMixin,DetailView):
    model = Animal
    template_name="core/animal_detail.html"

    def get_context_data(self, *args, **kwargs):
        ctx = super(DetailAnimal, self).get_context_data(*args, **kwargs)
        ctx['childs_list'] = Animal.objects.all()
        return ctx

class AnimalCreate(LoginRequiredMixin, CreateView):
    model = Animal
    fields = '__all__'
    success_url = reverse_lazy('animals:main_animal')

class AnimalUpdate(LoginRequiredMixin, UpdateView):
    model = Animal
    fields = '__all__'
    success_url = reverse_lazy('animals:main_animal')

class AnimalDelete(LoginRequiredMixin, DeleteView):
    model = Animal
    fields = '__all__'
    success_url = reverse_lazy('animals:main_animal')

#############################  ROUTINES  #########################################

class MainRoutine(ListView):
    model= Routine
    template_name = "core/routine_main.html"

class DetailRoutine(LoginRequiredMixin,DetailView):
    model = Routine
    template_name="core/routine_detail.html"

class RoutineCreate(LoginRequiredMixin, CreateView):
    model = Routine
    fields = '__all__'
    success_url = reverse_lazy('animals:main_routine')

class RoutineUpdate(LoginRequiredMixin, UpdateView):
    model = Routine
    fields = '__all__'
    success_url = reverse_lazy('animals:main_routine')

class RoutineDelete(LoginRequiredMixin, DeleteView):
    model = Routine
    fields = '__all__'
    success_url = reverse_lazy('animals:main_routine')

app/core/templates/animalsBase.html
{% extends 'base.html' %}
{% block title %}About Animals{% endblock title %}
{%load static%}

{% block nav %}
<nav class="navbar navbar-light" style="background-color: #bbbbee;">

   <a href="{% url 'animals:main' %}" class="navbar-brand"><img src="{% static 'core/img/magpie.svg' %}"></a>

   <a href="{% url 'animals:main_animal'%}" class="navbar-brand">See an animal</a>
   <a href="{% url 'animals:main_routine'%}" class="navbar-brand">See a routine</a>

   {% if user.is_authenticated %}
      <a href="{% url 'animals:create_animal'%}" class="navbar-brand">Add an animal</a>
      <a href="{% url 'animals:create_routine'%}" class="navbar-brand">Add a routine</a>
      <a href="{% url 'logout' %}?next={% url 'animals:main'  %}" class="navbar-brand">Logout</a>
   {% else %}
      <a href="{% url 'login' %}?next={% url 'animals:main' %}" class="navbar-brand">Login</a>
   {% endif %}
</nav>
{% endblock nav %}

{% block content %} {% endblock content %}

{% block footer %}
<footer style="background-color: #bbbbee; position: absolute;
  bottom: 0;
  width: 100%;
  height: 2em;
  text-align:center;
  color:#ffffff;">
   &copy2021  All rights deserved a honest justice
</footer>
{% endblock footer %}

app/core/templates/core/animal_confirm_delete.html
{% extends 'animalsBase.html' %}

{% block content %}

<h1>Delete Animal</h1>

<p>Delete the animal: {{ animal }}?</p>

<form action="" method="POST">
  {% csrf_token %}
  <input type="submit" value="Send to the butcher.">
</form>
<a  href="{% url 'animals:main_animal' %}">Go Main</a>
{% endblock %}

app/core/templates/core/animal_detail.html
{% extends 'animalsBase.html' %}
{% block content %}
<p>
<h1>{{animal.name}}</h1>
</p>
<p>
<table class="table">
    <tr>
    <th>Species</th><th>Sex</th><th>Date of Birth</th><th>Parents</th><th>Kids</th>
    </tr>
    <tr>
        <td>
            {{animal.species}}</td><td>{{animal.sex}}
        </td>

        <td>
        {%if animal.dateOfBirth%}
            {{animal.dateOfBirth}}
        {%else%}
            unknown
        {%endif%}
        </td>

        <td>
        {%if animal.parents%}
            <a href="{%url 'animals:detail_animal' animal.parents.mother.id%}">{{animal.parents.mother.name}}</a>
            &
            <a href="{%url 'animals:detail_animal' animal.parents.father.id%}">{{animal.parents.father.name}}</a>
        {%endif%}</td>

        <td>
        {%for child in childs_list%}
            {%if child.parents.mother.id == animal.id or child.parents.father.id == animal.id%}
                <a href="{%url 'animals:detail_animal' child.id%}">{{child.name}}</a>
            {%endif%}
        {%endfor%}
        </td>
    </tr>
</table>
</p>


{% endblock %}

app/core/templates/core/animal_form.html
{% extends "animalsBase.html" %}
{% load crispy_forms_tags%}
{% block content %}
<h1>Animal creating</h1>
<form action="" method="post">
    {% csrf_token %}
    {{ form|crispy }}
    <input type="submit" value="Submit">
    <input type="submit" onclick="window.location='{% url 'animals:main_animal' %}' ; return false;" value="Cancel">
  </form>
{% endblock %}

app/core/templates/core/animal_main.html
{% extends 'animalsBase.html' %}
{% block content %}
{% load static %}

<h1>Animals</h1>

<ul class="list-group-flush" >
    {%for animal in animal_list%}
    <li class="list-group-item">
        <a href="{% url 'animals:detail_animal' animal.id%}">{{animal.name}}</a>
        The {{animal.species}}
        {% if user.is_authenticated %}
         |
        <a href="{% url 'animals:update_animal' animal.id%}"><img src="{% static 'core/img/icon-changelink.svg' %}" alt="edit"></a>
        <a href="{% url 'animals:delete_animal' animal.id%}"><img src="{% static 'core/img/icon-deletelink.svg' %}" alt="delete"></a>
        {% endif %}
    </li>
    {%endfor%}
</ul>


{% endblock %}

app/core/templates/core/main.html
{% extends 'animalsBase.html' %}
{% block content %}
{% load static %}

<h1>About Animals</h1>

    {% if user.is_authenticated%}
   <p>Hey there {{user}}!</p>
    <p>There are {{countAnimals}} animals and {{countRoutines}} routines at the web. </p>

    {%else%}
    If you want all inclusive, you should <a href="{% url 'login' %}?next={% url 'animals:main' %}">Log in</a>
    {%endif%}



{% endblock %}

app/core/templates/core/routine_confirm_delete.html
{% extends 'animalsBase.html' %}

{% block content %}

<h1>Delete Routine</h1>

<p>Delete the routine: {{ routine }}?</p>

<form action="" method="POST">
  {% csrf_token %}
  <input type="submit" value="Delete">
</form>
<a  href="{% url 'animals:main_routine' %}">Go Main</a>
{% endblock %}

app/core/templates/core/routine_detail.html
{% extends 'animalsBase.html' %}
{% block content %}
<h1>{{routine.name}}</h1>
<table class="table">
    <tr>
    <th>Routine Type</th><th>Animal</th><th>Starts at</th>
    </tr>
    <tr>
        <td>{{routine.routineType}}</td><td>{{routine.animal}}</td><td>{{routine.startsAt}}</td>
    </tr>
</table>
<a  href="{% url 'animals:main_routine' %}">Go Main</a>
{% endblock %}

app/core/templates/core/routine_form.html
{% extends "animalsBase.html" %}
{% load crispy_forms_tags%}
{% block content %}
<h1> Routine creating</h1>
<form action="" method="post">
    {% csrf_token %}
    {{ form|crispy }}
    <input type="submit" value="Submit">
    <input type="submit" onclick="window.location='{% url 'animals:main_routine' %}' ; return false;" value="Cancel">
  </form>
{% endblock %}

app/core/templates/core/routine_main.html
{% extends 'animalsBase.html' %}
{% block content %}
{% load static %}

<h1>Routine list</h1>
<ul class="list-group-flush" >
    {%for routine in routine_list%}
    <li class="list-group-item">
        <a href="{% url 'animals:detail_routine' routine.id%}">{{routine.name}}</a>
         {{routine.animal}}
        {% if user.is_authenticated %}
         |
        <a href="{% url 'animals:update_routine' routine.id%}"><img src="{% static 'core/img/icon-changelink.svg' %}" alt="edit"></a>
        <a href="{% url 'animals:delete_routine' routine.id%}"><img src="{% static 'core/img/icon-deletelink.svg' %}" alt="delete"></a>
        {% endif %}

    </li>
    {%endfor%}

</ul>
</div>
{% endblock %}

app/templates/base.html
<!DOCTYPE html>
<html lang="ru" xmlns="http://www.w3.org/1999/html">
{% load i18n %}

{% load static %}

<head>
    <meta charset="UTF-8">
    <title>{% block title %}{% endblock %}</title>

    <link rel="shortcut icon" type="image/png" href="{% static 'core/img/favi.ico' %}"/>
    <link rel="stylesheet" href="{% static 'core/css/style.css' %}" type="text/css">
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta2/dist/css/bootstrap.min.css" rel="stylesheet"
          integrity="sha384-BmbxuPwQa2lc/FVzBcNJ7UAyJxM6wuqIj61tLrc4wSX0szH/Ev+nYRRuWlolflfl" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js"
            integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN"
            crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js"
            integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q"
            crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js"
            integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl"
            crossorigin="anonymous"></script>
</head>

<body class="background" style="overflow-x: hidden;">
{%block nav%}{% endblock %}
<div class="container">

{%block content%}{% endblock %}
    </div>
    </div>
</div>
{% block footer %}{% endblock %}

</body>
</html>